import 'package:aliyun_oss_platform_interface/src/model/method_call_listener.dart';
import 'package:plugin_platform_interface/plugin_platform_interface.dart';
import 'src/method_channel_aliyun_oss.dart';

export 'src/method_channel_aliyun_oss.dart';
export 'src/event_channel_aliyun_oss.dart';
export 'constants.dart';
export 'src/model/export_model.dart';

class AliyunOSSPlatform extends PlatformInterface {
  AliyunOSSPlatform() : super(token: _token);

  static final Object _token = Object();
  OSSStsTokenCredentialProvider? provider;

  static AliyunOSSPlatform _instance = MethodChannelAliyunOSS();
  static AliyunOSSPlatform get instance => _instance;

  static set instance(AliyunOSSPlatform instance) {
    PlatformInterface.verify(instance, _token);
    _instance = instance;
  }

  getMd5Str(String filePath) {
    throw UnimplementedError("getMd5Str() has not been implemented.");
  }

  init(String endpoint, OSSCredentialProvider provider) {
    throw UnimplementedError('init() has not been implemented.');
  }

  upload(String bucketName) {
    throw UnimplementedError('putObject() has not been implemented.');
  }

  uploadWithPath(String bucketName, String filePath) {
    throw UnimplementedError('uploadWithPath() has not been implemented.');
  }

  Future<String?> pauseUpload(String objectKey) {
    throw UnimplementedError('pauseUpload() has not been implemented.');
  }

  Future<String?> resumeUpload(String objectKey) {
    throw UnimplementedError('resumeUpload() has not been implemented.');
  }

  void addMethodCallListener(MethodCallListener listener) {
    throw UnimplementedError(
        'addMethodCallListener() has not been implemented.');
  }

  void removeMethodCallListener(MethodCallListener listener) {
    throw UnimplementedError(
        'removeMethodCallListener() has not been implemented.');
  }
}
